/*
    (C) 1995-97 AROS - The Amiga Research OS
    $Id: freedosentry.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: english
*/
#include <proto/exec.h>
#include "dos_intern.h"

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH1(void, FreeDosEntry,

/*  SYNOPSIS */
	AROS_LHA(struct DosList *, dlist, D1),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 117, Dos)

/*  FUNCTION
	Frees a dos list entry created with MakeDosEntry().

    INPUTS
	dlist - pointer to dos list entry. May be NULL.

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

#if !USE_EARLYDOS
    FAILFORTASKNP(return;)
#endif

    if (dlist!=NULL)
    {

	/* 02-Aug-2003 bugfix: Must use FreeVec here!
	 * Filesystem's might swap this ptr! - Piru
	 */

#ifdef AROS_DOS_COMPATIBLE

	FreeVec(BADDR(dlist->dol_Name));

#else /* AROS_DOS_COMPATIBLE */

	FreeVec(dlist->dol_DevName-1);

#endif /* AROS_DOS_COMPATIBLE */

	dosFreeMem(dlist,sizeof(struct DosList));
    }

    AROS_LIBFUNC_EXIT
} /* FreeDosEntry */
